Spec.Mock = {objects: []};

Spec.Mock.spy = function(object, methodName, callback) {
	if (typeof methodName == "object") {
		for (var i in methodName) {
			spy(object, methodName[i]);
		};
		
		return;
	};
	
	var method = object[methodName];
	
	if (typeof method != "function" && !Spec.stubNonExistentFunction) {
		throw {
			name: "UnknownMethodError",
			message: attribute + "() method does not exist. Set Spec.stubNonExistentFunction if you want this"
		};
	};
	
	if (method.calls) {
		throw {
			name: "SpyAlreadySet",
			message: "The " + method + "() method already has a spy on it"
		};
	};
	
	stub(object, methodName, function(){
		var args = [],
			methodName = arguments.callee.methodName,
			stubId = arguments.callee.stubId,
			value;
		
		for (var i = 0; i < arguments.length; i++) {
			args.push(arguments[i]);
		}
		
		object.stubs[methodName].calls.push(args);
		
		return callback ? callback.apply(this, args) : object.stubs[methodName].value.apply(this, args);
	});
};

Spec.Mock.stub = function(object, name, value) {
	var matches;
	
	if (typeof value != "function") {
		matches = name.match(/^(.*?)\(\)$/);

		if (matches) {
			name = matches[1];
			value = (function(v){
				return function() { return v; };
			})(value);
		};
	};
	
	if (!object.stubs) {
		object.stubs = {};
	};
	
	if (!Spec.stubNonExistentFunction && typeof value == "function" && typeof object[name] != "function") {
		throw {
			name: "UnknownMethodError",
			message: name + "() method does not exist. Set Spec.stubNonExistentFunction if you want this"
		};
	};
	
	if (typeof object.stubId != "number") {
		object.stubId = Spec.Mock.objects.length;
		Spec.Mock.objects[object.stubId] = object;
	};
	
	if (!object.stubs[name]) {
		object.stubs[name] = {
			value: object[name],
			calls: []
		};
	};
	
	if (typeof value == "function") {
		value.methodName = name;
		value.stubId = object.stubId;
	};

	object[name] = value;
};

Spec.Mock.unstub = function(object) {
	for (var name in object.stubs) {
		object[name] = object.stubs[name].value;
	};
	
	object.stubs = undefined;
	Spec.Mock.objects[object.stubId] = undefined;
	Spec.Mock.objects.splice(object.stubId, 1);
	delete(object.stubId);
	delete(object.stubs);
};

Spec.Mock.unstubAll = function() {
	for (var i = Spec.Mock.objects.length - 1; i >= 0; i--) {
		Spec.Mock.unstub(Spec.Mock.objects[i]);
	};
};
