results = [];

describe("Callbacks triggering", function(){
	before(function(){
		results.push("before");
	});
	
	beforeAll(function(){
		results.push("before all");
	});
	
	after(function(){
		results.push("after");
	});
	
	afterAll(function(){
		results.push("after all");
	});
	
	should("just run all callbacks", function(){
		expect(true).toBeTrue();
	});
});

describe("Callbacks", function(){
	should("have executed callbacks in the right order", function(){
		expect(results[0]).toBeEqualTo("before all");
		expect(results[1]).toBeEqualTo("before");
		expect(results[2]).toBeEqualTo("after");
		expect(results[results.length - 1]).toBeEqualTo("after all");
	});
});

describe("Callback aliases", function(){
	should("add before_all alias", function(){
		expect(before_all).toBeEqualTo(beforeAll);
	});
	
	should("add after_all alias", function(){
		expect(after_all).toBeEqualTo(afterAll);
	});
});
