describe("Message parser", function(){
	before(function(){
		matcher = new Spec.Matcher();
	});
	
	should("return full message without placeholders", function(){
		expect(matcher.parseMessage("a full message")).toBeEqualTo("a full message");
	});
	
	should("return full message with placeholder for string", function(){
		text = matcher.parseMessage("string: %{text}", {text: "hello world"});
		expect(text).toBeEqualTo("string: hello world");
	});
	
	should("return full message with placeholder for number", function(){
		text = matcher.parseMessage("number: %{number}", {number: 1234});
		expect(text).toBeEqualTo("number: 1234");
	});
	
	should("return full message with placeholder for array", function(){
		text = matcher.parseMessage("array: %{array}", {array: [1,2,3]});
		expect(text).toBeEqualTo("array: [1,2,3]");
	});
});
