describe("jQuery integration", function(){
	window.location = Envjs.uri("spec/fixtures/sample.html");

	before(function(){
		window.location.reload();
	});
	
	// toHaveTag
	should("have 3 items", function(){
		expect($("body")).toHaveTag("li", 3);
	});

	specify("item 1 should 'Foo' as text", function(){
		expect($("body")).toHaveTag("li.item-1", "Foo");
	});

	specify("item 2 should 'Bar' as text", function(){
		expect($("body")).toHaveTag("li.item-2", /Bar/);
	});
	
	// toHaveText
	should("return text", function(){
		expect($("li.item-1")).toHaveText("Foo");
	});
	
	should("not return text", function(){
		expect($("li.item-1")).not.toHaveText("Bla");
	});
	
	// toHaveValue
	should("return value", function(){
		expect($("#text-input")).toHaveValue("Text Input");
	});
	
	should("not return value", function(){
		expect($("#text-input")).not.toHaveValue("Hidden Input");
	});
	
	// Just playing with env.js + jquery
	should("trigger event", function(){
		button = $("#button");
		$(button).click(function(){
			this.value = "You clicked me!";
		}).trigger("click");
		
		expect(button).toHaveValue("You clicked me!");
	});
});
